%input {
    font-family: inherit;
    font-size: inherit;
    display: flex;
    flex-direction: column;

    .wrapper {
        display: inline-flex;
        align-items: center;
        border: 1px solid $color-input-border;
        border-radius: $border-radius;
        background-color: $color-input-background;
        position: relative;
        flex-grow: 1;

        &:hover:not(.wrapper--disabled):not(.wrapper--error),
        &:active:not(.wrapper--disabled):not(.wrapper--error),
        &:focus:not(.wrapper--disabled):not(.wrapper--error),
        &.focus:not(.wrapper--disabled):not(.wrapper--error) {
            border-color: $color-input-focus;
        }

        &.wrapper--disabled {
            color: $color-input-disabled;
            background-color: $color-input-background-disabled;

            & * {
                cursor: not-allowed;
            }
        }

        &.wrapper--readonly {
            color: $color-input-readonly;
            background-color: $color-input-background;
        }

        .icon__left {
            flex-shrink: 0;
            color: $color-input-readonly;
        }

        .icon__right {
            flex-shrink: 0;
            color: $color-input-readonly;
        }

        &.wrapper--addon__left {
            border-top-left-radius: 0;
            border-bottom-left-radius: 0;
        }

        &.wrapper--addon__right {
            border-top-right-radius: 0;
            border-bottom-right-radius: 0;
        }

        input {
            font-family: inherit;
            font-size: inherit;
            color: inherit;
            background-color: $color-input-background;
            box-shadow: none;
            outline: none;
            border: 0 none;
            border-radius: $border-radius;
            width: 100%;
            line-height: $line-height;
            box-sizing: content-box;

            @include padding(2, 3);

            -moz-appearance: none;

            &::-webkit-outer-spin-button,
            &::-webkit-inner-spin-button {
                -webkit-appearance: none;
                margin: 0;
            }

            &::placeholder {
                color: $color-input-placeholder;
            }

            &[disabled] {
                color: $color-input-disabled;
                background-color: $color-input-background-disabled;
            }

            &[readonly] {
                color: $color-input-readonly;
                background-color: $color-input-background;
            }

            //&:invalid {
            //    border: 1px solid var(--color-input__border--error);
            //}
        }
    }

    .addon--wrapper {
        display: inline-flex;
        align-items: center;
        //border: 1px solid $color-input-border;
        border-radius: $border-radius;

        .addon {
            font-family: inherit;
            font-size: inherit;
            background-color: $color-addon-background;
            border: 1px solid $color-input-border;
            border-right-width: 0;
            @include paddingLeft(3);
            @include paddingRight(3);
            // какая-то странная фигня, но на один пиксель не совпадают размеры
            padding-top: calc(0.5rem + 1px);
            padding-bottom: calc(0.5rem);

            &.left {
                border-radius: $border-radius 0 0 $border-radius;
            }

            &.right {
                border-radius: 0 $border-radius $border-radius 0;
            }
        }
    }

    &.error {
        .wrapper {
            border-color: $color-input-border-error;

            .icon__left,
            .icon__right {
                cursor: default;
                color: $color-input-error;
            }
        }
    }

    &.disabled {
        .wrapper {
            .icon__left,
            .icon__right {
                cursor: not-allowed;
                color: $color-input-disabled;
            }
        }
    }

    &.readonly {
        .wrapper {
            .icon__left,
            .icon__right {
                cursor: default;
                color: $color-input-disabled;
            }
        }
    }

    &.label-position {
        &.top {
            display: flex;
            flex-wrap: nowrap;
            flex-direction: column;
            width: 100%;
        }

        &.left {
            display: flex;
            flex-wrap: nowrap;
            flex-direction: row;
            justify-content: space-between;
            align-items: flex-start;
            @include marginBottom(6);
        }
    }

    .label {
        display: flex;
        flex-wrap: nowrap;
        align-items: center;
        flex: 30%;
        color: $color-base;
        min-height: $line-height * 1em;
        @include padding(2, 3, 2, 0);

        .mark {
            color: $color-input-error;
            @include marginLeft(1);
        }

        .helper {
            @include marginLeft(2);
        }
    }

    .error--wrapper {
        flex: 70%;
        display: flex;
        flex-direction: column;

        .error {
            font-size: $font-size-small;
            color: $color-input-error;
            @include marginLeft(3);
        }
    }
}


.text {
    @extend %input;
}


.email {
    @extend %input;
}


.password {
    @extend %input;
}


.number {
    @extend %input;
}


.tel {
    @extend %input;
}


.url {
    @extend %input;
}


.search {
    @extend %input;
}

.date {
    @extend %input;
    position: relative;

    .wrapper {
        input {
            background-color: transparent;
            cursor: pointer;
            min-width: 6rem;
        }

        .icon__right {
            cursor: pointer;
        }
    }

    & ::-webkit-calendar-picker-indicator {
        cursor: pointer;
        display: block;
        -webkit-appearance: initial;
        position: absolute;
        top: 0;
        right: 0;
        width: 100%;
        height: 100%;
        padding: 0;
        color: transparent;
        background: transparent none;
    }
}
